(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', 'melon-core/InputComponent', 'melon-core/classname/cxBuilder', 'melon/Icon', 'melon/Confirm', './calendar/Panel', './util', 'lodash/omit'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('melon-core/InputComponent'), require('melon-core/classname/cxBuilder'), require('melon/Icon'), require('melon/Confirm'), require('./calendar/Panel'), require('./util'), require('lodash/omit'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.InputComponent, global.cxBuilder, global.Icon, global.Confirm, global.Panel, global.util, global.omit);
        global.Calendar = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _InputComponent2, _cxBuilder, _Icon, _Confirm, _Panel, _util, _omit) {
    'use strict';

    Object.defineProperty(exports, "__esModule", {
        value: true
    });

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _InputComponent3 = _interopRequireDefault(_InputComponent2);

    var _Icon2 = _interopRequireDefault(_Icon);

    var _Confirm2 = _interopRequireDefault(_Confirm);

    var _Panel2 = _interopRequireDefault(_Panel);

    var DateTime = _interopRequireWildcard(_util);

    var _omit2 = _interopRequireDefault(_omit);

    function _interopRequireWildcard(obj) {
        if (obj && obj.__esModule) {
            return obj;
        } else {
            var newObj = {};

            if (obj != null) {
                for (var key in obj) {
                    if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key];
                }
            }

            newObj.default = obj;
            return newObj;
        }
    }

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    function _objectWithoutProperties(obj, keys) {
        var target = {};

        for (var i in obj) {
            if (keys.indexOf(i) >= 0) continue;
            if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
            target[i] = obj[i];
        }

        return target;
    }

    var _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    var _createClass = function () {
        function defineProperties(target, props) {
            for (var i = 0; i < props.length; i++) {
                var descriptor = props[i];
                descriptor.enumerable = descriptor.enumerable || false;
                descriptor.configurable = true;
                if ("value" in descriptor) descriptor.writable = true;
                Object.defineProperty(target, descriptor.key, descriptor);
            }
        }

        return function (Constructor, protoProps, staticProps) {
            if (protoProps) defineProperties(Constructor.prototype, protoProps);
            if (staticProps) defineProperties(Constructor, staticProps);
            return Constructor;
        };
    }();

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    var _get = function get(object, property, receiver) {
        if (object === null) object = Function.prototype;
        var desc = Object.getOwnPropertyDescriptor(object, property);

        if (desc === undefined) {
            var parent = Object.getPrototypeOf(object);

            if (parent === null) {
                return undefined;
            } else {
                return get(parent, property, receiver);
            }
        } else if ("value" in desc) {
            return desc.value;
        } else {
            var getter = desc.get;

            if (getter === undefined) {
                return undefined;
            }

            return getter.call(receiver);
        }
    };

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var cx = (0, _cxBuilder.create)('Calendar');

    /**
     * melon 日期选择器
     *
     * @class
     * @extends {melon-core/InputComponent}
     */

    var Calendar = function (_InputComponent) {
        _inherits(Calendar, _InputComponent);

        /**
         * 构造函数
         *
         * @param  {Object} props   组件属性
         * @param  {Object} context 组件上下文
         * @public
         */
        function Calendar(props, context) {
            _classCallCheck(this, Calendar);

            var _this = _possibleConstructorReturn(this, (Calendar.__proto__ || Object.getPrototypeOf(Calendar)).call(this, props, context));

            _this.onLabelClick = _this.onLabelClick.bind(_this);
            _this.onConfirm = _this.onConfirm.bind(_this);
            _this.onLabelClick = _this.onLabelClick.bind(_this);
            _this.onCancel = _this.onCancel.bind(_this);
            _this.onDateChange = _this.onDateChange.bind(_this);

            var defaultValue = props.defaultValue,
                value = props.value;


            var date = value === void 0 ? defaultValue : value;

            /**
             * 组件状态
             *
             * @type {Object}
             */
            _this.state = _extends({}, _this.state, {

                value: _this.stringifyValue(date),

                // 缓存用户在 confirm 前的选中值
                date: date ? _this.parseDate(date) : void 0,

                // 是否打开选择窗
                open: false

            });

            return _this;
        }

        /**
         * react生命周期，组件将更新时触发
         *
         * @param {Object} _ 属性
         * @param {Object} nextState 状态
         */


        _createClass(Calendar, [{
            key: 'componentWillUpdate',
            value: function componentWillUpdate(_, nextState) {
                var date = this.parseDate(nextState.value);
                if (this.state.value !== nextState.value && (date === void 0 || nextState.date === void 0 || !DateTime.isEqualDate(date, nextState.date))) {
                    this.setState({
                        date: this.parseDate(nextState.value)
                    });
                }
            }
        }, {
            key: 'stringifyValue',
            value: function stringifyValue(rawValue) {

                if (!DateTime.isDate(rawValue)) {
                    return rawValue;
                }

                var dateFormat = this.props.dateFormat;
                return DateTime.format(rawValue, dateFormat);
            }
        }, {
            key: 'parseDate',
            value: function parseDate(date) {

                if (typeof date !== 'string') {
                    return date;
                }

                var format = this.props.dateFormat;

                return DateTime.parse(date, format);
            }
        }, {
            key: 'onLabelClick',
            value: function onLabelClick() {
                this.setState({ open: true });
            }
        }, {
            key: 'onConfirm',
            value: function onConfirm() {
                var _this2 = this;

                var _state = this.state,
                    value = _state.value,
                    date = _state.date;


                value = this.parseDate(value);

                if (value && DateTime.isEqualDate(date, this.parseDate(value))) {
                    this.setState({ open: false });
                    return;
                }

                var newDate = date ? date : new Date();

                this.setState({ open: false, date: newDate });

                _get(Calendar.prototype.__proto__ || Object.getPrototypeOf(Calendar.prototype), 'onChange', this).call(this, {
                    type: 'change',
                    target: this,
                    value: this.stringifyValue(newDate)
                }, function () {
                    _this2.setState({ open: false, date: newDate });
                });
            }
        }, {
            key: 'onCancel',
            value: function onCancel() {
                this.setState({ open: false });
            }
        }, {
            key: 'onDateChange',
            value: function onDateChange(e) {
                var _this3 = this;

                var value = this.parseDate(e.value);
                var newState = {
                    date: this.parseDate(value)
                };

                if (this.props.autoConfirm) {
                    _get(Calendar.prototype.__proto__ || Object.getPrototypeOf(Calendar.prototype), 'onChange', this).call(this, {
                        type: 'change',
                        target: this,
                        value: this.stringifyValue(value)
                    }, function () {
                        _this3.setState(_extends({}, newState, {
                            open: false
                        }));
                    });
                } else {
                    this.setState(newState);
                }
            }
        }, {
            key: 'renderHiddenInput',
            value: function renderHiddenInput() {
                var _props = this.props,
                    name = _props.name,
                    value = _props.value;


                return name ? _react2.default.createElement('input', {
                    name: name,
                    type: 'hidden',
                    value: value }) : null;
            }
        }, {
            key: 'render',
            value: function render() {
                var state = this.state,
                    props = this.props;

                var lang = props.lang,
                    disabled = props.disabled,
                    readOnly = props.readOnly,
                    size = props.size,
                    placeholder = props.placeholder,
                    others = _objectWithoutProperties(props, ['lang', 'disabled', 'readOnly', 'size', 'placeholder']);

                var value = state.value,
                    open = state.open,
                    date = state.date;
                var begin = props.begin,
                    end = props.end;


                begin = begin ? this.parseDate(begin) : null;
                end = end ? this.parseDate(end) : null;

                var className = cx(props).addStates({ focus: open }).addStates(this.getStyleStates()).build();

                return _react2.default.createElement(
                    'div',
                    _extends({}, (0, _omit2.default)(others, ['dateFormat', 'name', 'autoConfirm', 'variants', 'states']), { className: className }),
                    this.renderHiddenInput(),
                    _react2.default.createElement(
                        'label',
                        { onClick: disabled || readOnly ? null : this.onLabelClick },
                        value ? value : _react2.default.createElement(
                            'span',
                            { className: cx().part('label-placeholder').build() },
                            placeholder
                        ),
                        _react2.default.createElement(_Icon2.default, { icon: 'expand-more' })
                    ),
                    _react2.default.createElement(
                        _Confirm2.default,
                        {
                            open: open,
                            variants: ['calendar'],
                            onConfirm: this.onConfirm,
                            onCancel: this.onCancel,
                            size: size,
                            buttonVariants: ['secondery', 'calendar'] },
                        _react2.default.createElement(_Panel2.default, {
                            date: date,
                            begin: begin,
                            end: end,
                            lang: lang,
                            onChange: this.onDateChange })
                    )
                );
            }
        }]);

        return Calendar;
    }(_InputComponent3.default);

    exports.default = Calendar;


    Calendar.displayName = 'Calendar';

    Calendar.LANG = {

        // 对于 '周' 的称呼
        week: '周',

        // 星期对应的顺序表示
        days: '日,一,二,三,四,五,六'

    };

    Calendar.defaultProps = _extends({}, _InputComponent3.default.defaultProps, {
        dateFormat: 'YYYY-MM-DD',
        lang: Calendar.LANG,
        placeholder: '请选择'
    });

    Calendar.propTypes = _extends({}, _InputComponent3.default.propTypes, {

        value: _propTypes2.default.string,

        autoConfirm: _propTypes2.default.bool,

        dateFormat: _propTypes2.default.string,

        end: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.string]),

        begin: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.string]),

        lang: _propTypes2.default.shape({
            week: _propTypes2.default.string,
            days: _propTypes2.default.string
        })

    });

    Calendar.childContextTypes = _InputComponent3.default.childContextTypes;

    Calendar.contextTypes = _InputComponent3.default.contextTypes;
});
//# sourceMappingURL=Calendar.js.map
