(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', 'melon-core/classname/cxBuilder', 'melon-core/InputComponent', 'melon/Icon', 'melon/Confirm', './Calendar', './calendar/Panel', './util', 'lodash/omit'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('melon-core/classname/cxBuilder'), require('melon-core/InputComponent'), require('melon/Icon'), require('melon/Confirm'), require('./Calendar'), require('./calendar/Panel'), require('./util'), require('lodash/omit'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.cxBuilder, global.InputComponent, global.Icon, global.Confirm, global.Calendar, global.Panel, global.util, global.omit);
        global.RangeCalendar = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _cxBuilder, _InputComponent2, _Icon, _Confirm, _Calendar, _Panel, _util, _omit) {
    'use strict';

    Object.defineProperty(exports, "__esModule", {
        value: true
    });

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _InputComponent3 = _interopRequireDefault(_InputComponent2);

    var _Icon2 = _interopRequireDefault(_Icon);

    var _Confirm2 = _interopRequireDefault(_Confirm);

    var _Calendar2 = _interopRequireDefault(_Calendar);

    var _Panel2 = _interopRequireDefault(_Panel);

    var DateTime = _interopRequireWildcard(_util);

    var _omit2 = _interopRequireDefault(_omit);

    function _interopRequireWildcard(obj) {
        if (obj && obj.__esModule) {
            return obj;
        } else {
            var newObj = {};

            if (obj != null) {
                for (var key in obj) {
                    if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key];
                }
            }

            newObj.default = obj;
            return newObj;
        }
    }

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    function _objectWithoutProperties(obj, keys) {
        var target = {};

        for (var i in obj) {
            if (keys.indexOf(i) >= 0) continue;
            if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
            target[i] = obj[i];
        }

        return target;
    }

    var _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    var _createClass = function () {
        function defineProperties(target, props) {
            for (var i = 0; i < props.length; i++) {
                var descriptor = props[i];
                descriptor.enumerable = descriptor.enumerable || false;
                descriptor.configurable = true;
                if ("value" in descriptor) descriptor.writable = true;
                Object.defineProperty(target, descriptor.key, descriptor);
            }
        }

        return function (Constructor, protoProps, staticProps) {
            if (protoProps) defineProperties(Constructor.prototype, protoProps);
            if (staticProps) defineProperties(Constructor, staticProps);
            return Constructor;
        };
    }();

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    var _get = function get(object, property, receiver) {
        if (object === null) object = Function.prototype;
        var desc = Object.getOwnPropertyDescriptor(object, property);

        if (desc === undefined) {
            var parent = Object.getPrototypeOf(object);

            if (parent === null) {
                return undefined;
            } else {
                return get(parent, property, receiver);
            }
        } else if ("value" in desc) {
            return desc.value;
        } else {
            var getter = desc.get;

            if (getter === undefined) {
                return undefined;
            }

            return getter.call(receiver);
        }
    };

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var cx = (0, _cxBuilder.create)('RangeCalendar');

    /**
     * melon 日期区间选择器
     *
     * @class
     * @extends {melon-core/InputComponent}
     */

    var RangeCalendar = function (_InputComponent) {
        _inherits(RangeCalendar, _InputComponent);

        /**
         * 构造函数
         *
         * @param  {Object} props   组件属性
         * @param  {Object} context 组件上下文
         * @public
         */
        function RangeCalendar(props, context) {
            _classCallCheck(this, RangeCalendar);

            var _this = _possibleConstructorReturn(this, (RangeCalendar.__proto__ || Object.getPrototypeOf(RangeCalendar)).call(this, props, context));

            var begin = props.begin,
                end = props.end;


            var value = _this.state.value;

            /**
             * 组件状态
             *
             * @type {Object}
             */
            _this.state = _extends({}, _this.state, {
                open: false,
                date: _this.getNormalizeValue(value, begin, end)
            });

            _this.onLabelClick = _this.onLabelClick.bind(_this);
            _this.onConfirm = _this.onConfirm.bind(_this);
            _this.onLabelClick = _this.onLabelClick.bind(_this);
            _this.onCancel = _this.onCancel.bind(_this);
            _this.onDateChange = _this.onDateChange.bind(_this);
            return _this;
        }

        /**
         * 获取过滤后的日期对象区间
         *
         * @param  {Array<string>} value 时间区间值
         * @param  {string|Date}   begin 范围最新值
         * @param  {string|Date}   end   范围最大值
         * @return {Array<Date>}         日期对象区间
         * @private
         */


        _createClass(RangeCalendar, [{
            key: 'getNormalizeValue',
            value: function getNormalizeValue(value, begin, end) {

                if (value.length === 0) {
                    return [new Date(), new Date()];
                }

                begin = this.parseDate(begin);
                end = this.parseDate(end);

                var valueBegin = this.parseDate(value[0]);
                var valueEnd = this.parseDate(value[1]);

                // 这里我们需要一个全新的 value
                value = [begin && DateTime.isAfterDate(begin, valueBegin) ? begin : valueBegin, end && DateTime.isBeforeDate(end, valueEnd) ? end : valueEnd];

                return value;
            }
        }, {
            key: 'stringifyValue',
            value: function stringifyValue(date) {
                var _this2 = this;

                return date.map(function (date) {
                    return _this2.formatDate(date);
                });
            }
        }, {
            key: 'onLabelClick',
            value: function onLabelClick() {
                var _props = this.props,
                    disabled = _props.disabled,
                    readOnly = _props.readOnly;


                if (disabled || readOnly) {
                    return;
                }

                this.setState({ open: true });
            }
        }, {
            key: 'onCancel',
            value: function onCancel() {
                this.setState({
                    open: false
                });
            }
        }, {
            key: 'onDateChange',
            value: function onDateChange(index, e) {

                var value = e.value;

                var date = [].concat(this.state.date);

                date[index] = value;

                this.setState({
                    date: date
                });
            }
        }, {
            key: 'onConfirm',
            value: function onConfirm() {
                var _this3 = this;

                var _state = this.state,
                    date = _state.date,
                    value = _state.value;


                // 不管怎么样，先把窗口关了
                this.setState({
                    open: false
                }, function () {

                    // 如果值发生了变化，那么释放一个 change 事件
                    if (!DateTime.isEqualDate(date[0], _this3.parseDate(value[0])) || !DateTime.isEqualDate(date[1], _this3.parseDate(value[1]))) {
                        _get(RangeCalendar.prototype.__proto__ || Object.getPrototypeOf(RangeCalendar.prototype), 'onChange', _this3).call(_this3, {
                            type: 'change',
                            target: _this3,
                            value: date.map(_this3.formatDate, _this3)
                        });
                    }
                });
            }
        }, {
            key: 'formatDate',
            value: function formatDate(date) {

                return DateTime.format(date, this.props.dateFormat);
            }
        }, {
            key: 'parseDate',
            value: function parseDate(date) {

                if (typeof date !== 'string') {
                    return date;
                }

                var format = this.props.dateFormat;

                return DateTime.parse(date, format);
            }
        }, {
            key: 'renderHiddenInput',
            value: function renderHiddenInput() {
                var _props2 = this.props,
                    name = _props2.name,
                    value = _props2.value;


                return name ? _react2.default.createElement('input', {
                    name: name,
                    type: 'hidden',
                    value: value.join(',') }) : null;
            }
        }, {
            key: 'render',
            value: function render() {

                var props = this.props;

                var lang = props.lang,
                    disabled = props.disabled,
                    readOnly = props.readOnly,
                    size = props.size,
                    begin = props.begin,
                    end = props.end,
                    placeholder = props.placeholder,
                    others = _objectWithoutProperties(props, ['lang', 'disabled', 'readOnly', 'size', 'begin', 'end', 'placeholder']);

                var _state2 = this.state,
                    open = _state2.open,
                    date = _state2.date,
                    value = _state2.value;


                begin = begin ? this.parseDate(begin) : null;
                end = end ? this.parseDate(end) : null;

                var className = cx(props).addStates({ focus: open }).addStates(this.getStyleStates()).build();

                return _react2.default.createElement(
                    'div',
                    _extends({}, (0, _omit2.default)(others, ['dateFormat', 'name', 'autoConfirm', 'variants', 'states']), {
                        className: className }),
                    this.renderHiddenInput(),
                    _react2.default.createElement(
                        'label',
                        { onClick: disabled || readOnly ? null : this.onLabelClick },
                        value.length === 0 ? _react2.default.createElement(
                            'span',
                            { className: cx().part('label-placeholder').build() },
                            placeholder
                        ) : value[0] + ' \u81F3 ' + value[1],
                        _react2.default.createElement(_Icon2.default, { icon: 'expand-more' })
                    ),
                    _react2.default.createElement(
                        _Confirm2.default,
                        {
                            open: open,
                            variants: ['calendar', 'range'],
                            onConfirm: this.onConfirm,
                            onCancel: this.onCancel,
                            size: size,
                            buttonVariants: ['secondery', 'calendar'] },
                        _react2.default.createElement(
                            'div',
                            { className: cx().part('row').build() },
                            _react2.default.createElement(_Panel2.default, {
                                lang: lang,
                                date: date[0],
                                begin: begin,
                                end: date[1] || new Date(),
                                onChange: this.onDateChange.bind(this, 0) }),
                            _react2.default.createElement(_Panel2.default, {
                                lang: lang,
                                date: date[1],
                                begin: date[0] || new Date(),
                                end: end,
                                onChange: this.onDateChange.bind(this, 1) })
                        )
                    )
                );
            }
        }]);

        return RangeCalendar;
    }(_InputComponent3.default);

    exports.default = RangeCalendar;


    RangeCalendar.displayName = 'RangeCalendar';

    RangeCalendar.defaultProps = _extends({}, _Calendar2.default.defaultProps, {
        defaultValue: [],
        placeholder: '请选择'
    });

    RangeCalendar.propTypes = _extends({}, _Calendar2.default.propTypes, {
        defaultValue: _propTypes2.default.arrayOf(_propTypes2.default.string),
        value: _propTypes2.default.arrayOf(_propTypes2.default.string),
        autoOk: _propTypes2.default.bool,
        dateFormat: _propTypes2.default.string,
        begin: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.string]),
        end: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.string])
    });

    RangeCalendar.childContextTypes = _InputComponent3.default.childContextTypes;

    RangeCalendar.contextTypes = _InputComponent3.default.contextTypes;
});
//# sourceMappingURL=RangeCalendar.js.map
