(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', 'melon-core/classname/cxBuilder', 'melon-core/InputComponent', 'melon/BoxGroup', './util', 'lodash/omit'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('melon-core/classname/cxBuilder'), require('melon-core/InputComponent'), require('melon/BoxGroup'), require('./util'), require('lodash/omit'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.cxBuilder, global.InputComponent, global.BoxGroup, global.util, global.omit);
        global.UnitCalendar = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _cxBuilder, _InputComponent2, _BoxGroup, _util, _omit) {
    'use strict';

    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.normalize = normalize;
    exports.getNextTime = getNextTime;
    exports.getContinuousFragments = getContinuousFragments;

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _InputComponent3 = _interopRequireDefault(_InputComponent2);

    var _BoxGroup2 = _interopRequireDefault(_BoxGroup);

    var date = _interopRequireWildcard(_util);

    var _omit2 = _interopRequireDefault(_omit);

    function _interopRequireWildcard(obj) {
        if (obj && obj.__esModule) {
            return obj;
        } else {
            var newObj = {};

            if (obj != null) {
                for (var key in obj) {
                    if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key];
                }
            }

            newObj.default = obj;
            return newObj;
        }
    }

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    var _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    function _objectWithoutProperties(obj, keys) {
        var target = {};

        for (var i in obj) {
            if (keys.indexOf(i) >= 0) continue;
            if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
            target[i] = obj[i];
        }

        return target;
    }

    function _toConsumableArray(arr) {
        if (Array.isArray(arr)) {
            for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) {
                arr2[i] = arr[i];
            }

            return arr2;
        } else {
            return Array.from(arr);
        }
    }

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    var _createClass = function () {
        function defineProperties(target, props) {
            for (var i = 0; i < props.length; i++) {
                var descriptor = props[i];
                descriptor.enumerable = descriptor.enumerable || false;
                descriptor.configurable = true;
                if ("value" in descriptor) descriptor.writable = true;
                Object.defineProperty(target, descriptor.key, descriptor);
            }
        }

        return function (Constructor, protoProps, staticProps) {
            if (protoProps) defineProperties(Constructor.prototype, protoProps);
            if (staticProps) defineProperties(Constructor, staticProps);
            return Constructor;
        };
    }();

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    var _get = function get(object, property, receiver) {
        if (object === null) object = Function.prototype;
        var desc = Object.getOwnPropertyDescriptor(object, property);

        if (desc === undefined) {
            var parent = Object.getPrototypeOf(object);

            if (parent === null) {
                return undefined;
            } else {
                return get(parent, property, receiver);
            }
        } else if ("value" in desc) {
            return desc.value;
        } else {
            var getter = desc.get;

            if (getter === undefined) {
                return undefined;
            }

            return getter.call(receiver);
        }
    };

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var cx = (0, _cxBuilder.create)('UnitCalendar');

    /**
     * melon 日期区间选择器
     *
     * @class
     * @extends {melon-core/InputComponent}
     */

    var UnitCalendar = function (_InputComponent) {
        _inherits(UnitCalendar, _InputComponent);

        /**
         * 构造函数
         *
         * @param  {Object} props   组件属性
         * @param  {Object} context 组件上下文
         * @public
         */
        function UnitCalendar(props, context) {
            _classCallCheck(this, UnitCalendar);

            var _this = _possibleConstructorReturn(this, (UnitCalendar.__proto__ || Object.getPrototypeOf(UnitCalendar)).call(this, props, context));

            _this.onChange = _this.onChange.bind(_this);
            _this.parse = _this.parse.bind(_this);
            _this.format = _this.format.bind(_this);
            return _this;
        }

        /**
         * BoxGroup 改变时触发
         *
         * @param  {Object} e 事件对象
         * @private
         */


        _createClass(UnitCalendar, [{
            key: 'onChange',
            value: function onChange(e) {

                var nextValue = e.value;

                var value = this.state.value;

                _get(UnitCalendar.prototype.__proto__ || Object.getPrototypeOf(UnitCalendar.prototype), 'onChange', this).call(this, {

                    type: 'change',

                    target: this,

                    // 如果是连续的，这里需要算一下，不是连续的就以新值为主
                    value: this.props.continuous ? this.calculate(value, nextValue).map(this.parse) : value
                });
            }
        }, {
            key: 'calculate',
            value: function calculate(current, next) {

                current = current.map(this.format).sort();

                next = next.sort();

                var cLength = current.length;
                var nLength = next.length;
                var unit = this.props.unit;

                if (cLength === nLength) {
                    return current;
                }

                if (!cLength || !nLength) {
                    return next;
                }

                // fill
                if (cLength < nLength) {

                    var firtNext = new Date(next[0]);
                    var firstCurrent = new Date(current[0]);

                    if (firtNext < firstCurrent) {
                        return [].concat(_toConsumableArray(getContinuousFragments(firtNext, firstCurrent, unit).map(this.format)), _toConsumableArray(current));
                    }

                    var lastNext = new Date(next[nLength - 1]);
                    lastNext.setDate(lastNext.getDate() + 1);
                    var lastCurrent = new Date(current[cLength - 1]);

                    return current.concat(getContinuousFragments(lastCurrent, lastNext, unit).slice(1).map(this.format));
                }

                // cut
                for (var i = 0; i < nLength; ++i) {
                    if (current[i] < next[i]) {
                        if (i === 0) {
                            return current.slice(1);
                        }
                        return current.slice(0, i);
                    }
                }

                return current.slice(0, -1);
            }
        }, {
            key: 'parse',
            value: function parse(time) {
                return date.parse(time, this.props.format);
            }
        }, {
            key: 'format',
            value: function format(time) {
                return date.format(time, this.props.format);
            }
        }, {
            key: 'parseValue',
            value: function parseValue() {
                var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

                return value.split(',').map(function (date) {
                    return this.parse(date);
                });
            }
        }, {
            key: 'stringifyValue',
            value: function stringifyValue() {
                var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

                return value.map(function (term) {
                    return this.format(term);
                }).join(',');
            }
        }, {
            key: 'render',
            value: function render() {
                var _this2 = this;

                var _props = this.props,
                    begin = _props.begin,
                    end = _props.end,
                    unit = _props.unit,
                    format = _props.format,
                    rest = _objectWithoutProperties(_props, ['begin', 'end', 'unit', 'format']);

                var value = this.state.value;

                value = value.map(function (fragment) {
                    return date.format(normalize(fragment, unit), format);
                }).sort();

                var options = getContinuousFragments(begin, end, unit).map(function (fragment) {
                    var begin = _this2.format(fragment);
                    var end = getNextTime(fragment, unit);
                    end.setDate(end.getDate() - 1);
                    end = _this2.format(end);
                    return _react2.default.createElement('option', { key: begin, value: begin, label: begin + ' ~ ' + end });
                });

                return _react2.default.createElement(
                    'div',
                    { className: cx(this.props).build() },
                    _react2.default.createElement(
                        _BoxGroup2.default,
                        _extends({}, (0, _omit2.default)(rest, ['defaultValue']), {
                            boxModel: 'checkbox',
                            onChange: this.onChange,
                            value: value }),
                        options
                    )
                );
            }
        }]);

        return UnitCalendar;
    }(_InputComponent3.default);

    exports.default = UnitCalendar;


    UnitCalendar.propTypes = _extends({}, _InputComponent3.default.propTypes, {
        begin: _propTypes2.default.instanceOf(Date),
        end: _propTypes2.default.instanceOf(Date),
        unit: _propTypes2.default.oneOf(['week', 'month', 'year']).isRequired,
        value: _propTypes2.default.arrayOf(Date),
        continuous: _propTypes2.default.bool.isRequired,
        defaultValue: _propTypes2.default.arrayOf(_propTypes2.default.string)
    });

    UnitCalendar.defaultProps = _extends({}, _InputComponent3.default.defaultProps, {
        continuous: true,
        defaultValue: [],
        format: 'YYYY-MM-DD'
    });

    UnitCalendar.childContextTypes = _InputComponent3.default.childContextTypes;
    UnitCalendar.contextTypes = _InputComponent3.default.contextTypes;

    /**
     * 处理时间对象，只留下当前单位需要的部分
     *
     * @param  {Date}   time 时间
     * @param  {string} unit 单位
     * @return {Date}
     */
    function normalize(time, unit) {
        time = new Date(time);
        // 得到周一
        if (unit === 'week') {
            time.setDate(time.getDate() - time.getDay() + 1);
        }
        // 得到1日
        else if (unit === 'month') {
                time.setDate(1);
            }
            // 得到1月1日
            else {
                    time.setMonth(0);
                    time.setDate(1);
                }
        return time;
    }

    /**
     * 处理时间对象，返回当前单位下下一个值
     *
     * @param  {Date}   time 时间
     * @param  {string} unit 单位
     * @return {Date}
     */
    function getNextTime(time, unit) {
        time = normalize(time, unit);
        if (unit === 'week') {
            time.setDate(time.getDate() + 7);
        } else if (unit === 'month') {
            time.setMonth(time.getMonth() + 1);
        } else {
            time.setFullYear(time.getFullYear() + 1);
        }
        return time;
    }

    /**
     * 获取所允许的时间区间
     *
     * @param  {Date} begin   起始时间
     * @param  {Date} end     结束时间
     * @param  {string} unit  单位
     * @return {Array<Date>}
     */
    function getContinuousFragments(begin, end, unit) {

        begin = normalize(begin, unit);

        var result = [];

        while (begin < end) {
            result.push(new Date(begin));
            if (unit === 'week') {
                begin.setDate(begin.getDate() + 7);
            } else if (unit === 'month') {
                begin.setMonth(begin.getMonth() + 1);
            } else {
                begin.setFullYear(begin.getFullYear() + 1);
            }
        }

        return result;
    }
});
//# sourceMappingURL=UnitCalendar.js.map
