(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', '../util', 'melon-core/classname/cxBuilder'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('../util'), require('melon-core/classname/cxBuilder'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.util, global.cxBuilder);
        global.Header = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _util, _cxBuilder) {
    'use strict';

    Object.defineProperty(exports, "__esModule", {
        value: true
    });

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var DateTime = _interopRequireWildcard(_util);

    function _interopRequireWildcard(obj) {
        if (obj && obj.__esModule) {
            return obj;
        } else {
            var newObj = {};

            if (obj != null) {
                for (var key in obj) {
                    if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key];
                }
            }

            newObj.default = obj;
            return newObj;
        }
    }

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    var _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    function _objectWithoutProperties(obj, keys) {
        var target = {};

        for (var i in obj) {
            if (keys.indexOf(i) >= 0) continue;
            if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
            target[i] = obj[i];
        }

        return target;
    }

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    var _createClass = function () {
        function defineProperties(target, props) {
            for (var i = 0; i < props.length; i++) {
                var descriptor = props[i];
                descriptor.enumerable = descriptor.enumerable || false;
                descriptor.configurable = true;
                if ("value" in descriptor) descriptor.writable = true;
                Object.defineProperty(target, descriptor.key, descriptor);
            }
        }

        return function (Constructor, protoProps, staticProps) {
            if (protoProps) defineProperties(Constructor.prototype, protoProps);
            if (staticProps) defineProperties(Constructor, staticProps);
            return Constructor;
        };
    }();

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var cx = (0, _cxBuilder.create)('CalendarHeader');

    /**
     * CalendarHeader
     *
     * @class
     * @extends {React.Component}
     */

    var CalendarHeader = function (_Component) {
        _inherits(CalendarHeader, _Component);

        function CalendarHeader() {
            _classCallCheck(this, CalendarHeader);

            return _possibleConstructorReturn(this, (CalendarHeader.__proto__ || Object.getPrototypeOf(CalendarHeader)).apply(this, arguments));
        }

        _createClass(CalendarHeader, [{
            key: 'render',
            value: function render() {
                var _props = this.props,
                    date = _props.date,
                    rest = _objectWithoutProperties(_props, ['date']);

                var year = date.getFullYear();

                var week = DateTime.getDayOfWeek(date);
                var month = DateTime.getShortMonth(date);
                var day = date.getDate();

                var fullDate = month + day + '日';

                return _react2.default.createElement(
                    'div',
                    _extends({}, rest, { className: cx(this.props).build() }),
                    _react2.default.createElement(
                        'p',
                        { className: cx.getPartClassName('year') },
                        year
                    ),
                    _react2.default.createElement(
                        'p',
                        { className: cx.getPartClassName('week') },
                        week
                    ),
                    _react2.default.createElement(
                        'p',
                        { className: cx.getPartClassName('date') },
                        fullDate
                    )
                );
            }
        }]);

        return CalendarHeader;
    }(_react.Component);

    exports.default = CalendarHeader;


    CalendarHeader.displayName = 'CalendarHeader';

    CalendarHeader.propTypes = {
        date: _propTypes2.default.object.isRequired
    };
});
//# sourceMappingURL=Header.js.map
