(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react);
        global.Item = mod.exports;
    }
})(this, function (exports, _react) {
    'use strict';

    Object.defineProperty(exports, "__esModule", {
        value: true
    });

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    var _createClass = function () {
        function defineProperties(target, props) {
            for (var i = 0; i < props.length; i++) {
                var descriptor = props[i];
                descriptor.enumerable = descriptor.enumerable || false;
                descriptor.configurable = true;
                if ("value" in descriptor) descriptor.writable = true;
                Object.defineProperty(target, descriptor.key, descriptor);
            }
        }

        return function (Constructor, protoProps, staticProps) {
            if (protoProps) defineProperties(Constructor.prototype, protoProps);
            if (staticProps) defineProperties(Constructor, staticProps);
            return Constructor;
        };
    }();

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var Item = function (_Component) {
        _inherits(Item, _Component);

        /**
         * 构造函数
         *
         * @param  {Object} props   组件属性
         * @public
         */
        function Item(props) {
            _classCallCheck(this, Item);

            var _this = _possibleConstructorReturn(this, (Item.__proto__ || Object.getPrototypeOf(Item)).call(this, props));

            _this.onClick = _this.onClick.bind(_this);
            return _this;
        }

        /**
         * 判断是否需要更新，性能优化
         *
         * @param  {Object} nextProps  组件新的属性
         * @return {bool}  是否需要更新
         * @public
         */


        _createClass(Item, [{
            key: 'shouldComponentUpdate',
            value: function shouldComponentUpdate(nextProps) {
                var _props = this.props,
                    disabled = _props.disabled,
                    selected = _props.selected;


                return nextProps.disabled !== disabled || nextProps.selected !== selected;
            }
        }, {
            key: 'onClick',
            value: function onClick(e) {

                e.preventDefault();

                var _props2 = this.props,
                    disabled = _props2.disabled,
                    onClick = _props2.onClick,
                    date = _props2.date,
                    mode = _props2.mode;


                if (disabled) {
                    return;
                }

                if (onClick) {

                    var _e = {
                        target: this,
                        date: date
                    };

                    if (mode) {
                        _e.mode = mode;
                    }

                    onClick(_e);
                }
            }
        }]);

        return Item;
    }(_react.Component);

    exports.default = Item;
});
//# sourceMappingURL=Item.js.map
