(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', 'melon-core/classname/cxBuilder', './Header', './Selector', './Pager', './Month', '../util'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('melon-core/classname/cxBuilder'), require('./Header'), require('./Selector'), require('./Pager'), require('./Month'), require('../util'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.cxBuilder, global.Header, global.Selector, global.Pager, global.Month, global.util);
        global.Panel = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _cxBuilder, _Header, _Selector, _Pager, _Month, _util) {
    'use strict';

    Object.defineProperty(exports, "__esModule", {
        value: true
    });

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _Header2 = _interopRequireDefault(_Header);

    var _Selector2 = _interopRequireDefault(_Selector);

    var _Pager2 = _interopRequireDefault(_Pager);

    var _Month2 = _interopRequireDefault(_Month);

    var DateTime = _interopRequireWildcard(_util);

    function _interopRequireWildcard(obj) {
        if (obj && obj.__esModule) {
            return obj;
        } else {
            var newObj = {};

            if (obj != null) {
                for (var key in obj) {
                    if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key];
                }
            }

            newObj.default = obj;
            return newObj;
        }
    }

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    var _createClass = function () {
        function defineProperties(target, props) {
            for (var i = 0; i < props.length; i++) {
                var descriptor = props[i];
                descriptor.enumerable = descriptor.enumerable || false;
                descriptor.configurable = true;
                if ("value" in descriptor) descriptor.writable = true;
                Object.defineProperty(target, descriptor.key, descriptor);
            }
        }

        return function (Constructor, protoProps, staticProps) {
            if (protoProps) defineProperties(Constructor.prototype, protoProps);
            if (staticProps) defineProperties(Constructor, staticProps);
            return Constructor;
        };
    }();

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var cx = (0, _cxBuilder.create)('CalendarPanel');

    /**
     * melon-calendar 日期选择主面板
     *
     * @class
     * @extends {React.Component}
     */

    var CalendarPanel = function (_Component) {
        _inherits(CalendarPanel, _Component);

        /**
         * 构造函数
         *
         * @param  {Object} props   组件属性
         * @public
         */
        function CalendarPanel(props) {
            _classCallCheck(this, CalendarPanel);

            var _this = _possibleConstructorReturn(this, (CalendarPanel.__proto__ || Object.getPrototypeOf(CalendarPanel)).call(this, props));

            _this.onHeaderClick = _this.onHeaderClick.bind(_this);
            _this.onSelectorChange = _this.onSelectorChange.bind(_this);
            _this.onPagerChange = _this.onPagerChange.bind(_this);
            _this.onDateChange = _this.onDateChange.bind(_this);

            // 除年月日以外的时间数据清0
            var d = props.date;
            var date = new Date(d.getFullYear(), d.getMonth(), d.getDate());

            /**
             * 组件状态
             *
             * @type {Object}
             */
            _this.state = {
                selectorType: 'main',
                month: date,
                date: date
            };

            return _this;
        }

        /**
         * 组件每次更新属性时判断是否需要同步状态
         *
         * @param  {Object} nextProps 新属性
         * @public
         */


        _createClass(CalendarPanel, [{
            key: 'componentWillReceiveProps',
            value: function componentWillReceiveProps(nextProps) {

                var date = nextProps.date;

                if (!DateTime.isEqualDate(date, this.props.date)) {
                    this.setState({
                        date: date,
                        month: date
                    });
                }
            }
        }, {
            key: 'shouldComponentUpdate',
            value: function shouldComponentUpdate(nextProps, nextState) {
                return !DateTime.isEqualDate(nextState.date, this.state.date) || !DateTime.isEqualMonth(nextState.month, this.state.month) || nextState.selectorType !== this.state.selectorType || nextProps.begin && this.props.begin && !DateTime.isEqualDate(nextProps.begin, this.props.begin) || nextProps.end && this.props.end && !DateTime.isEqualDate(nextProps.end, this.props.end) || !nextProps.begin && this.props.begin || !nextProps.end && this.props.end || nextProps.begin && !this.props.begin || nextProps.end && !this.props.end;
            }
        }, {
            key: 'onHeaderClick',
            value: function onHeaderClick(e) {

                var selectorType = this.state.selectorType;

                this.setState({
                    selectorType: selectorType === 'main' ? 'year' : 'main'
                });
            }
        }, {
            key: 'onSelectorChange',
            value: function onSelectorChange(e) {
                var mode = e.mode,
                    date = e.date;
                var _props = this.props,
                    end = _props.end,
                    begin = _props.begin;


                mode = mode === 'year' ? 'month' : 'main';

                if (begin && DateTime.isBeforeDate(date, begin)) {
                    date = begin;
                } else if (end && DateTime.isAfterDate(date, end)) {
                    date = end;
                }

                this.setState({
                    date: date,
                    month: date,
                    selectorType: mode
                });
            }
        }, {
            key: 'onPagerChange',
            value: function onPagerChange(e) {
                this.setState({ month: e.month });
            }
        }, {
            key: 'onDateChange',
            value: function onDateChange(e) {

                var date = e.date;

                var month = this.state.month;
                var monthDiff = DateTime.monthDiff(date, month);

                if (monthDiff !== 0) {
                    this.setState({
                        month: DateTime.addMonths(month, monthDiff)
                    });
                }

                this.props.onChange({
                    value: date
                });
            }
        }, {
            key: 'render',
            value: function render() {
                var _props2 = this.props,
                    lang = _props2.lang,
                    begin = _props2.begin,
                    end = _props2.end;


                var date = this.state.date;

                var _state = this.state,
                    selectorType = _state.selectorType,
                    month = _state.month;


                return _react2.default.createElement(
                    'div',
                    { className: cx(this.props).build() },
                    _react2.default.createElement(_Header2.default, {
                        date: date,
                        onClick: this.onHeaderClick }),
                    _react2.default.createElement(
                        'div',
                        { className: cx().part('main').build() },
                        _react2.default.createElement(_Pager2.default, {
                            minDate: begin,
                            maxDate: end,
                            onChange: this.onPagerChange,
                            month: month }),
                        _react2.default.createElement(_Month2.default, {
                            minDate: begin,
                            maxDate: end,
                            lang: lang,
                            month: month,
                            date: date,
                            onChange: this.onDateChange }),
                        _react2.default.createElement(_Selector2.default, {
                            style: { display: selectorType === 'main' ? 'none' : null },
                            date: date,
                            mode: selectorType === 'year' ? 'year' : 'month',
                            minDate: begin,
                            maxDate: end,
                            onChange: this.onSelectorChange })
                    )
                );
            }
        }]);

        return CalendarPanel;
    }(_react.Component);

    exports.default = CalendarPanel;


    CalendarPanel.displayName = 'CalendarPanel';

    CalendarPanel.defaultProps = {
        date: new Date()
    };

    CalendarPanel.propTypes = {
        date: _propTypes2.default.instanceOf(Date).isRequired,
        begin: _propTypes2.default.instanceOf(Date),
        end: _propTypes2.default.instanceOf(Date)
    };
});
//# sourceMappingURL=Panel.js.map
