(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', 'melon-core/classname/cxBuilder', './Item', '../util'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('melon-core/classname/cxBuilder'), require('./Item'), require('../util'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.cxBuilder, global.Item, global.util);
        global.SelectorItem = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _cxBuilder, _Item2, _util) {
    'use strict';

    Object.defineProperty(exports, "__esModule", {
        value: true
    });

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _Item3 = _interopRequireDefault(_Item2);

    var DateTime = _interopRequireWildcard(_util);

    function _interopRequireWildcard(obj) {
        if (obj && obj.__esModule) {
            return obj;
        } else {
            var newObj = {};

            if (obj != null) {
                for (var key in obj) {
                    if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key];
                }
            }

            newObj.default = obj;
            return newObj;
        }
    }

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    var _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    function _objectWithoutProperties(obj, keys) {
        var target = {};

        for (var i in obj) {
            if (keys.indexOf(i) >= 0) continue;
            if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
            target[i] = obj[i];
        }

        return target;
    }

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    var _createClass = function () {
        function defineProperties(target, props) {
            for (var i = 0; i < props.length; i++) {
                var descriptor = props[i];
                descriptor.enumerable = descriptor.enumerable || false;
                descriptor.configurable = true;
                if ("value" in descriptor) descriptor.writable = true;
                Object.defineProperty(target, descriptor.key, descriptor);
            }
        }

        return function (Constructor, protoProps, staticProps) {
            if (protoProps) defineProperties(Constructor.prototype, protoProps);
            if (staticProps) defineProperties(Constructor, staticProps);
            return Constructor;
        };
    }();

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var cx = (0, _cxBuilder.create)('CalendarSelectorItem');

    /**
     * melon-calendar 年、月选择单元
     *
     * @class
     * @extends {Item}
     */

    var CalendarSelectorItem = function (_Item) {
        _inherits(CalendarSelectorItem, _Item);

        function CalendarSelectorItem() {
            _classCallCheck(this, CalendarSelectorItem);

            return _possibleConstructorReturn(this, (CalendarSelectorItem.__proto__ || Object.getPrototypeOf(CalendarSelectorItem)).apply(this, arguments));
        }

        _createClass(CalendarSelectorItem, [{
            key: 'render',
            value: function render() {

                var props = this.props;

                var date = props.date,
                    mode = props.mode,
                    disabled = props.disabled,
                    selected = props.selected,
                    others = _objectWithoutProperties(props, ['date', 'mode', 'disabled', 'selected']);

                return _react2.default.createElement(
                    'li',
                    _extends({}, others, {
                        'data-mode': mode,
                        'data-value': date,
                        onClick: disabled ? null : this.onClick,
                        className: cx(props).addStates({ selected: selected }).build() }),
                    _react2.default.createElement(
                        'span',
                        null,
                        mode === 'year' ? date.getFullYear() : DateTime.getShortMonth(date)
                    )
                );
            }
        }]);

        return CalendarSelectorItem;
    }(_Item3.default);

    exports.default = CalendarSelectorItem;


    CalendarSelectorItem.displayName = 'CalendarSelectorItem';

    CalendarSelectorItem.propTypes = {
        date: _propTypes2.default.object.isRequired,
        onClick: _propTypes2.default.func,
        disabled: _propTypes2.default.bool,
        selected: _propTypes2.default.bool,
        mode: _propTypes2.default.oneOf(['month', 'year'])
    };
});
//# sourceMappingURL=SelectorItem.js.map
